#!/usr/bin/env python
# -*- coding: utf-8 -*

import os
import shutil

BASE58 = '123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ'
def base58encode(value):
    encoded = ''
    while value >= 58:
        div, mod = divmod(value, 58)
        encoded = BASE58[mod] + encoded
        value = div
    encoded = BASE58[value] + encoded
    return encoded

def base58decode(encoded):
    value = 0
    column_multiplier = 1
    for c in encoded[::-1]:
        column = BASE58.index(c)
        value += column * column_multiplier
        column_multiplier *= 58
    return value

for cf in os.listdir('.'):
    if cf.endswith('.txt'):
        string = cf[:-4]
        uid = base58decode(string)
        if uid > 0xFFFFFFFF:
            # convert from 64bit to 32bit
            value1 = uid & 0xFFFFFFFF
            value2 = (uid >> 32) & 0xFFFFFFFF

            uid  = (value1 & 0x00000FFF)
            uid |= (value1 & 0x0F000000) >> 12
            uid |= (value2 & 0x0000003F) << 16
            uid |= (value2 & 0x000F0000) << 6
            uid |= (value2 & 0x3F000000) << 2

            cp_from = cf
            cp_to = base58encode(uid) + '.txt'
            if not os.path.isfile(cp_to):
                print 'Copying: ' + cp_to + ' <- ' + cp_from
                shutil.copy(cp_from, cp_to)
            else:
                print 'Not Copying (collision): ' + cp_to + ' <- ' + cp_from

